Botan 2.1.0 Crypto and TLS for C++11

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | List of all members
Botan::Intel_Rdseed Class Referencefinal

`#include <rdseed.h>`

Inheritance diagram for Botan::Intel_Rdseed:

## Public Member Functions
std::string | name () const override
size_t | poll (RandomNumberGenerator &rng) override

## Static Public Member Functions
static std::unique_ptr< Entropy_Source > | create (const std::string &type)

## Detailed Description

Entropy source using the rdseed instruction first introduced on Intel's Broadwell architecture.

Definition at line 19 of file rdseed.h.

## Member Function Documentation

std::unique_ptr< Entropy_Source > Botan::Entropy_Source::create | ( | const std::string & | type | ) |
| static inherited

Return a new entropy source of a particular type, or null Each entropy source may require substantial resources (eg, a file handle or socket instance), so try to share them among multiple RNGs, or just use the preconfigured global list accessed by Entropy_Sources::global_sources()

Definition at line 45 of file entropy_srcs.cpp.

Referenced by Botan::Entropy_Sources::Entropy_Sources().

46 {
47 if(name == "rdrand")
48 {
49 #if defined(BOTAN_HAS_ENTROPY_SRC_RDRAND)
50 return std::unique_ptr<Entropy_Source>(new Intel_Rdrand);
51 #endif
52 }
53
54 if(name == "rdseed")
55 {
56 #if defined(BOTAN_HAS_ENTROPY_SRC_RDSEED)
57 return std::unique_ptr<Entropy_Source>(new Intel_Rdseed);
58 #endif
59 }
60
61 if(name == "darwin_secrandom")
62 {
63 #if defined(BOTAN_HAS_ENTROPY_SRC_DARWIN_SECRANDOM)
64 return std::unique_ptr<Entropy_Source>(new Darwin_SecRandom);
65 #endif
66 }
67
68 if(name == "getentropy")
69 {
70 #if defined(BOTAN_HAS_ENTROPY_SRC_GETENTROPY)
71 return std::unique_ptr<Entropy_Source>(new Getentropy);
72 #endif
73 }
74
75 if(name == "dev_random")
76 {
77 #if defined(BOTAN_HAS_ENTROPY_SRC_DEV_RANDOM)
78 return std::unique_ptr<Entropy_Source>(new Device_EntropySource(BOTAN_SYSTEM_RNG_POLL_DEVICES));
79 #endif
80 }
81
82 if(name == "win32_cryptoapi")
83 {
84 #if defined(BOTAN_HAS_ENTROPY_SRC_CAPI)
85 return std::unique_ptr<Entropy_Source>(new Win32_CAPI_EntropySource("RSA_FULL"));
86 #endif
87 }
88
89 if(name == "proc_walk")
90 {
91 #if defined(BOTAN_HAS_ENTROPY_SRC_PROC_WALKER)
92 const std::string root_dir = BOTAN_ENTROPY_PROC_FS_PATH;
93 if(!root_dir.empty())
94 return std::unique_ptr<Entropy_Source>(new ProcWalking_EntropySource(root_dir));
95 #endif
96 }
97
98 if(name == "system_stats")
99 {
100 #if defined(BOTAN_HAS_ENTROPY_SRC_WIN32)
101 return std::unique_ptr<Entropy_Source>(new Win32_EntropySource);
102 #endif
103 }
104
105 return std::unique_ptr<Entropy_Source>();
106 }
Botan::Entropy_Source::name
virtual std::string name() const =0

std::string Botan::Intel_Rdseed::name | ( |  | ) | const
| inline override virtual

Returns
  name identifying this entropy source

Implements Botan::Entropy_Source.

Definition at line 22 of file rdseed.h.

22 { return "rdseed"; }

size_t Botan::Intel_Rdseed::poll | ( | RandomNumberGenerator & | rng | ) |
| override virtual

Perform an entropy gathering poll

Parameters

  rng | will be provided with entropy via calls to add_entropy

Returns
  conservative estimate of actual entropy added to rng during poll

Implements Botan::Entropy_Source.

Definition at line 19 of file rdseed.cpp.

19 {
20 if(CPUID::has_rdseed())
21 {
22 for(size_t p = 0; p != BOTAN_ENTROPY_INTEL_RNG_POLLS; ++p)
23 {
24 for(size_t i = 0; i != BOTAN_ENTROPY_RDSEED_RETRIES; ++i)
25 {
26 uint32_t r = 0;
27
28 #if defined(BOTAN_USE_GCC_INLINE_ASM)
29 int cf = 0;
30
31 // Encoding of rdseed %eax
32 asm(".byte 0x0F, 0xC7, 0xF8; adcl $0,%1" :
33 "=a" (r), "=r" (cf) : "0" (r), "1" (cf) : "cc");
34 #else
35 int cf = _rdseed32_step(&r);
36 #endif
37 if(1 == cf)
38 {
39 rng.add_entropy_T(r);
40 break;
41 }
42 }
43 }
44 }
45
46 return 0;
47 }

The documentation for this class was generated from the following files:

- src/lib/entropy/rdseed/rdseed.h
- src/lib/entropy/rdseed/rdseed.cpp